[[> :header]]

<div id="home-head">
    <bs-row>
      <bs-col sm=12>
        <div class="global_search">
          <semantic-simple-search
            config='{
              "query":"
              PREFIX fn: <http://www.w3.org/2005/xpath-functions#>
              SELECT DISTINCT ?uri ?label ?type ?typelabel ?typelabelLC WHERE {
                ?uri a ?type .
                ?uri ecrm:P3_has_note|
                  rdfs:label|
                  (ecrm:P1_is_identified_by/ecrm:P3_has_note)|
                  (ecrm:P102_has_title/ecrm:P3_has_note)|
                  (ecrm:P128_carries/ecrm:P102_has_title/ecrm:P3_has_note)|
                  (ecrm:PC01_is_domain_of/ecrm:PC02_has_range/ecrm:P3_has_note)|
                  (^oa:hasTarget/oa:hasBody/cnt:chars)
                  ?label.
                OPTIONAL {
                  ?type rdfs:label ?typelabel .
                }
                ?label bds:search \"?token*\".
                ?label  bds:relevance ?score .
                VALUES ( ?type ?typelabel ) {
                  ( sphaera:Book \"Book\" )
                  ( sphaera:Part \"Part\" )
                  ( sphaera:Part_Adaption \"Adaption\" )
                  ( efrbroo:F10_Person \"Person\" )
                  ( ecrm:E53_Place \"Place\" )
              }
              BIND(fn:lower-case(?typelabel) as ?typelabelLC)
            } ORDER BY DESC(?score) LIMIT 10",
            "searchTermVariable":"token",
            "resultTemplate":"
              <semantic-link
                uri=\":view{{typelabel.value}}\"
                urlqueryparam-{{typelabelLC.value}}iri=\"{{uri.value}}\">
                <span title=\"{{uri.value}}\">{{label.value}} {{#if typelabel.value}}<small>({{typelabel.value}})</small>{{else}}({{type.value}}){{/if}}</span>
              </semantic-link>
            ",
            "inputPlaceholder":"Search for something&hellip;"
            }'>
          </semantic-simple-search>
        </div>
      </bs-col>
    </bs-row>
</div>

[[#if (hasPermission "forms:ldp:*")]]
  <div id="admin-actions" class="gap-bottom">
    <bs-row>
      <bs-col md=8>
        <semantic-link
          uri=":createBook"
          class="btn btn-primary"
        >Add new Book</semantic-link>
        <semantic-link
          uri=":createPerson"
          class="btn btn-primary"
        >Add new Person</semantic-link>
      </bs-col>
      <bs-col md=4 class="text-right">
          [[#if (hasPermission "api:config")]]
            <semantic-link
              uri="http://www.mpiwg-berlin.mpg.de/FieldDefinitionCatalog"
              class="btn btn-default pull-right"
            >Manage Fields</semantic-link>
              <semantic-link
                uri=":lastEdits"
                class="btn btn-default pull-right"
              >Last Edits</semantic-link>
          [[/if]]
      </bs-col>
    </bs-row>
  </div>
[[/if]]

<div id="home-body" class="content">

    <bs-row>
      <bs-col md=6 sm=12>
        <h2>Books</h2>
        <semantic-query
          query='SELECT (COUNT(?book) as ?num_books) WHERE { ?book a sphaera:Book }'
          template='{{#each bindings}}<p>There are currently {{num_books.value}} books in the database.</p>{{/each}}'
        >
        </semantic-query>
        <semantic-link class="btn btn-default btn-secondary btn-md" uri=":listBooks">List all books</semantic-link>

        <h4>Recently edited</h4>

        <semantic-query
          query='SELECT DISTINCT ?book ?label ?book_title ?date_published ?year_published_from ?year_published_to ?years_equal ?generated (GROUP_CONCAT(DISTINCT ?author_label; SEPARATOR=", ") as ?authors) (GROUP_CONCAT(DISTINCT ?translator_label; SEPARATOR=", ") as ?translators) (GROUP_CONCAT(DISTINCT ?publisher_label; SEPARATOR=", ") as ?publishers) WHERE {
            ?book a sphaera:Book ;
				ecrm:P3_has_note ?label;
  				ecrm:P128_carries ?publication_expression .

            ?publication_expression ecrm:P165_incorporates/efrbroo:R17i_was_created_by ?expression_creation .

            OPTIONAL {
          	   ?publication_expression ecrm:P102_has_title/ecrm:P3_has_note ?book_title .
            }

  			    OPTIONAL {
              ?expression_creation ecrm:PC01_is_domain_of ?carried_out_by .
              ?carried_out_by a ecrm:PC14_carried_out_by .
          		  ?carried_out_by ecrm:P14.1_in_the_role_of sphRole:author ;
                  ecrm:PC02_has_range/ecrm:P48_has_preferred_identifier/ecrm:P3_has_note ?author .
                [[> :queryFormatName input="?author" output="?author_label"]]
            }
            OPTIONAL {
              ?publication_expression efrbroo:R24i_was_created_through/ecrm:P4_has_time-span ?publication_date .
              OPTIONAL {
                ?publication_date ecrm:P3_has_note ?date_published .
              }
              OPTIONAL {
          	   	?publication_date ecrm:P82a_begin_of_the_beginning ?date_published_from .
                  BIND(SUBSTR(STR(?date_published_from),0,4) as ?year_published_from)
              }
              OPTIONAL {
          	   	?publication_date ecrm:P82b_end_of_the_end ?date_published_to .
                  BIND(SUBSTR(STR(?date_published_to),0,4) as ?year_published_to)
              }
          	  BIND(xsd:string(if(?year_published_from = ?year_published_to,"true", "")) as ?years_equal)
            }
            OPTIONAL {
              ?publication_expression efrbroo:R24i_was_created_through/ecrm:PC01_is_domain_of/ecrm:PC02_has_range/ecrm:P48_has_preferred_identifier/ecrm:P3_has_note ?publisher .
              [[> :queryFormatName input="?publisher" output="?publisher_label"]]
            }

  			GRAPH ?g {
  				?book a sphaera:Book .
				?container <http://www.w3.org/ns/prov#generatedAtTime> ?generated .
            }
          }
          GROUP BY ?book ?label ?book_title ?date_published ?year_published_from ?year_published_to ?years_equal ?generated
          ORDER BY DESC(?generated)
          LIMIT 10'
          template='{{#each bindings}}
            <div class="panel panel-default">
              <div class="panel-body">
                <dl>
                  <dt>Title</dt>
                  <dd>
                    <strong>
                      <semantic-link uri=":viewBook" urlqueryparam-bookiri="{{book.value}}" class="title">
                        {{#if book_title.value}}
                          {{book_title.value}}
                        {{else}}
                          {{label.value}}
                        {{/if}}
                      </semantic-link>
                    </strong>
                  </dd>
                  {{#if authors.value}}
                    <dt>Author</dt>
                    <dd>
                      {{authors.value}}
                    </dd>
                  {{/if}}
                  {{#if translators.value}}
                    <dt>Translator</dt>
                    <dd>
                      {{translators.value}}
                    </dd>
                  {{/if}}
                  {{#if publishers.value}}
                    <dt>Publisher</dt>
                    <dd>
                      {{publishers.value}}
                    </dd>
                  {{/if}}
                  <dt>Date of publication</dt>
                  <dd>
                    {{#if date_published.value}}
                      {{date_published.value}}
                    {{else}}
                      {{#if year_published_from}}
                        {{#if years_equal.value}}
                          {{year_published_from.value}}
                        {{else}}
                          between {{year_published_from.value}} and {{year_published_to.value}}
                        {{/if}}
                      {{/if}}
                    {{/if}}
                  </dd>
                </dl>
                <div class="text-right">
                  [[#if (hasPermission "forms:ldp:*")]]
                    <semantic-link uri="{{book.value}}" class="btn btn-default btn-sm">Edit</semantic-link>
                  [[/if]]
                  <semantic-link uri=":viewBook" urlqueryparam-bookiri="{{book.value}}" class="btn btn-primary btn-sm">View</semantic-link>
                </div>
              </div>
            </div>
          {{/each}}'
          >
        </semantic-query>
      </bs-col>
      <bs-col md=6 sm=12>
        <h2>Persons</h2>
        <semantic-query
          query='SELECT (COUNT(?person) as ?num_persons) WHERE { ?person a efrbroo:F10_Person }'
          template='{{#each bindings}}<p>There are currently {{num_persons.value}} persons in the database.</p>{{/each}}'
        >
        </semantic-query>
        <semantic-link class="btn btn-default btn-secondary btn-md" uri=":listPersons">List all persons</semantic-link>
        <h4>Recently edited</h4>
        <semantic-query
          query='SELECT DISTINCT ?person ?label (SAMPLE(YEAR(?dateOfBirth)) as ?yearOfBirth) (SAMPLE(YEAR(?dateOfDeath)) as ?yearOfDeath) ?image ?generated ?label_formatted WHERE {
            ?person a efrbroo:F10_Person ;
          	ecrm:P48_has_preferred_identifier/ecrm:P3_has_note ?label .
            ?container <http://www.w3.org/ns/prov#generatedAtTime> ?generated .

            [[> :queryFormatName input="?label" output="?label_formatted"]]
            BIND(URI(CONCAT(STR(?person), "/container")) as ?container)

            OPTIONAL {
              ?person owl:sameAs ?wdPerson .
              SERVICE <https://wikidata.metaphacts.com/sparql> {

                OPTIONAL {
                  ?wdPerson <http://www.wikidata.org/prop/direct/P569> ?dateOfBirth .
                }
                OPTIONAL {
                  ?wdPerson <http://www.wikidata.org/prop/direct/P570> ?dateOfDeath .
                }
                OPTIONAL {
                  ?wdPerson <http://www.wikidata.org/prop/direct/P18> ?image .
                }
              }
            }
          }
          GROUP BY ?person ?label ?image ?generated ?label_formatted
          ORDER BY DESC(?generated)
          LIMIT 15'
          template='{{#each bindings}}
            <div class="panel panel-default">
              <div class="panel-body">
                <dl>
                  <dt>Name</dt>
                  <dd>
                    <semantic-link uri=":viewPerson" urlqueryparam-personiri="{{person.value}}" class="title">
                      <strong>
                        {{label_formatted.value}}
                      </strong>
                    </semantic-link>
                  </dd>
                  {{#if yearOfBirth.value}}
                    <dt>Dates</dt>
                  {{else}}
                    {{#if yearOfDeath.value}}
                      <dt>Dates</dt>
                    {{/if}}
                  {{/if}}
                  <dd>
                    {{yearOfBirth.value}}
                    {{#if yearOfBirth.value}}
                      &ndash;
                    {{else}}
                      {{#if yearOfDeath.value}}
                        &ndash;
                      {{/if}}
                    {{/if}}
                    {{yearOfDeath/value}}
                  </dd>
                  <dt></dt>
                  <dd>
                    {{#if image.value}}
                      <img class="panel-fill" src="{{image.value}}" title="An image depicting {{label.value}}" />
                    {{/if}}
                  </dd>
                </dl>
                <div class="text-right">
                  [[#if (hasPermission "forms:ldp:*")]]
                    <semantic-link uri="{{person.value}}" class="btn btn-default btn-sm">Edit</semantic-link>
                  [[/if]]
                  <semantic-link uri=":viewPerson" urlqueryparam-personiri="{{person.value}}" class="btn btn-primary btn-sm">View</semantic-link>
                </div>
              </div>
            </div>
          {{/each}}'
      </bs-col>
    </bs-row>

</div>

[[> :footer]]
